#ifndef _H_F516F2E018EFCED88444AD0AF5560DB9_Gpgga__H_
#define _H_F516F2E018EFCED88444AD0AF5560DB9_Gpgga__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace nmea_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Gpgga_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::String_mgr message_id_;
                ::DDS::Double utc_seconds_;
                ::DDS::Double lat_;
                ::DDS::Double lon_;
                ::DDS::String_mgr lat_dir_;
                ::DDS::String_mgr lon_dir_;
                ::DDS::ULong gps_qual_;
                ::DDS::ULong num_sats_;
                ::DDS::Float hdop_;
                ::DDS::Float alt_;
                ::DDS::String_mgr altitude_units_;
                ::DDS::Float undulation_;
                ::DDS::String_mgr undulation_units_;
                ::DDS::ULong diff_age_;
                ::DDS::String_mgr station_id_;
            };

            typedef DDS_DCPSStruct_var<Gpgga_> Gpgga__var;
            typedef DDS_DCPSStruct_out < Gpgga_> Gpgga__out;

        }

    }

}

#endif /* _H_F516F2E018EFCED88444AD0AF5560DB9_Gpgga__H_ */
