#ifndef _H_A575B1D28AD609CCCB1E7BD828FD4FFD_GpgsvSatellite_DCPS_H_
#define _H_A575B1D28AD609CCCB1E7BD828FD4FFD_GpgsvSatellite_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GpgsvSatellite_.h"


namespace nmea_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GpgsvSatellite_TypeSupportInterface;

            typedef GpgsvSatellite_TypeSupportInterface * GpgsvSatellite_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GpgsvSatellite_TypeSupportInterface> GpgsvSatellite_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GpgsvSatellite_TypeSupportInterface> GpgsvSatellite_TypeSupportInterface_out;


            class GpgsvSatellite_DataWriter;

            typedef GpgsvSatellite_DataWriter * GpgsvSatellite_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GpgsvSatellite_DataWriter> GpgsvSatellite_DataWriter_var;
            typedef DDS_DCPSInterface_out < GpgsvSatellite_DataWriter> GpgsvSatellite_DataWriter_out;


            class GpgsvSatellite_DataReader;

            typedef GpgsvSatellite_DataReader * GpgsvSatellite_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GpgsvSatellite_DataReader> GpgsvSatellite_DataReader_var;
            typedef DDS_DCPSInterface_out < GpgsvSatellite_DataReader> GpgsvSatellite_DataReader_out;


            class GpgsvSatellite_DataReaderView;

            typedef GpgsvSatellite_DataReaderView * GpgsvSatellite_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GpgsvSatellite_DataReaderView> GpgsvSatellite_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GpgsvSatellite_DataReaderView> GpgsvSatellite_DataReaderView_out;

            struct GpgsvSatellite_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GpgsvSatellite_, struct GpgsvSatellite_Seq_uniq_> GpgsvSatellite_Seq;
            typedef DDS_DCPSSequence_var < GpgsvSatellite_Seq> GpgsvSatellite_Seq_var;
            typedef DDS_DCPSSequence_out < GpgsvSatellite_Seq> GpgsvSatellite_Seq_out;

            class  GpgsvSatellite_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GpgsvSatellite_TypeSupportInterface_ptr _ptr_type;
                typedef GpgsvSatellite_TypeSupportInterface_var _var_type;

                static GpgsvSatellite_TypeSupportInterface_ptr _duplicate (GpgsvSatellite_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpgsvSatellite_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GpgsvSatellite_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GpgsvSatellite_TypeSupportInterface () {};
                ~GpgsvSatellite_TypeSupportInterface () {};
            private:
                GpgsvSatellite_TypeSupportInterface (const GpgsvSatellite_TypeSupportInterface &);
                GpgsvSatellite_TypeSupportInterface & operator = (const GpgsvSatellite_TypeSupportInterface &);
            };

            class  GpgsvSatellite_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GpgsvSatellite_DataWriter_ptr _ptr_type;
                typedef GpgsvSatellite_DataWriter_var _var_type;

                static GpgsvSatellite_DataWriter_ptr _duplicate (GpgsvSatellite_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpgsvSatellite_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GpgsvSatellite_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GpgsvSatellite_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GpgsvSatellite_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GpgsvSatellite_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GpgsvSatellite_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GpgsvSatellite_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GpgsvSatellite_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GpgsvSatellite_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GpgsvSatellite_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GpgsvSatellite_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GpgsvSatellite_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GpgsvSatellite_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpgsvSatellite_& instance_data) = 0;

            protected:
                GpgsvSatellite_DataWriter () {};
                ~GpgsvSatellite_DataWriter () {};
            private:
                GpgsvSatellite_DataWriter (const GpgsvSatellite_DataWriter &);
                GpgsvSatellite_DataWriter & operator = (const GpgsvSatellite_DataWriter &);
            };

            class  GpgsvSatellite_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GpgsvSatellite_DataReader_ptr _ptr_type;
                typedef GpgsvSatellite_DataReader_var _var_type;

                static GpgsvSatellite_DataReader_ptr _duplicate (GpgsvSatellite_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpgsvSatellite_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GpgsvSatellite_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpgsvSatellite_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpgsvSatellite_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpgsvSatellite_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpgsvSatellite_& instance) = 0;

            protected:
                GpgsvSatellite_DataReader () {};
                ~GpgsvSatellite_DataReader () {};
            private:
                GpgsvSatellite_DataReader (const GpgsvSatellite_DataReader &);
                GpgsvSatellite_DataReader & operator = (const GpgsvSatellite_DataReader &);
            };

            class  GpgsvSatellite_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GpgsvSatellite_DataReaderView_ptr _ptr_type;
                typedef GpgsvSatellite_DataReaderView_var _var_type;

                static GpgsvSatellite_DataReaderView_ptr _duplicate (GpgsvSatellite_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpgsvSatellite_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpgsvSatellite_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GpgsvSatellite_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpgsvSatellite_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpgsvSatellite_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpgsvSatellite_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpgsvSatellite_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpgsvSatellite_& instance) = 0;

            protected:
                GpgsvSatellite_DataReaderView () {};
                ~GpgsvSatellite_DataReaderView () {};
            private:
                GpgsvSatellite_DataReaderView (const GpgsvSatellite_DataReaderView &);
                GpgsvSatellite_DataReaderView & operator = (const GpgsvSatellite_DataReaderView &);
            };
        }

    }

}

#endif
