#ifndef _H_597A21E0BFE782FFE6888982DF469295_Sentence_DCPS_H_
#define _H_597A21E0BFE782FFE6888982DF469295_Sentence_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Sentence_.h"


namespace nmea_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Sentence_TypeSupportInterface;

            typedef Sentence_TypeSupportInterface * Sentence_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sentence_TypeSupportInterface> Sentence_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sentence_TypeSupportInterface> Sentence_TypeSupportInterface_out;


            class Sentence_DataWriter;

            typedef Sentence_DataWriter * Sentence_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sentence_DataWriter> Sentence_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sentence_DataWriter> Sentence_DataWriter_out;


            class Sentence_DataReader;

            typedef Sentence_DataReader * Sentence_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sentence_DataReader> Sentence_DataReader_var;
            typedef DDS_DCPSInterface_out < Sentence_DataReader> Sentence_DataReader_out;


            class Sentence_DataReaderView;

            typedef Sentence_DataReaderView * Sentence_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sentence_DataReaderView> Sentence_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sentence_DataReaderView> Sentence_DataReaderView_out;

            struct Sentence_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sentence_, struct Sentence_Seq_uniq_> Sentence_Seq;
            typedef DDS_DCPSSequence_var < Sentence_Seq> Sentence_Seq_var;
            typedef DDS_DCPSSequence_out < Sentence_Seq> Sentence_Seq_out;

            class  Sentence_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sentence_TypeSupportInterface_ptr _ptr_type;
                typedef Sentence_TypeSupportInterface_var _var_type;

                static Sentence_TypeSupportInterface_ptr _duplicate (Sentence_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sentence_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sentence_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sentence_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sentence_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sentence_TypeSupportInterface () {};
                ~Sentence_TypeSupportInterface () {};
            private:
                Sentence_TypeSupportInterface (const Sentence_TypeSupportInterface &);
                Sentence_TypeSupportInterface & operator = (const Sentence_TypeSupportInterface &);
            };

            class  Sentence_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sentence_DataWriter_ptr _ptr_type;
                typedef Sentence_DataWriter_var _var_type;

                static Sentence_DataWriter_ptr _duplicate (Sentence_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sentence_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sentence_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sentence_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sentence_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sentence_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sentence_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sentence_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sentence_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sentence_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sentence_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sentence_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sentence_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sentence_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sentence_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sentence_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sentence_& instance_data) = 0;

            protected:
                Sentence_DataWriter () {};
                ~Sentence_DataWriter () {};
            private:
                Sentence_DataWriter (const Sentence_DataWriter &);
                Sentence_DataWriter & operator = (const Sentence_DataWriter &);
            };

            class  Sentence_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sentence_DataReader_ptr _ptr_type;
                typedef Sentence_DataReader_var _var_type;

                static Sentence_DataReader_ptr _duplicate (Sentence_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sentence_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sentence_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sentence_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sentence_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sentence_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sentence_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sentence_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sentence_& instance) = 0;

            protected:
                Sentence_DataReader () {};
                ~Sentence_DataReader () {};
            private:
                Sentence_DataReader (const Sentence_DataReader &);
                Sentence_DataReader & operator = (const Sentence_DataReader &);
            };

            class  Sentence_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sentence_DataReaderView_ptr _ptr_type;
                typedef Sentence_DataReaderView_var _var_type;

                static Sentence_DataReaderView_ptr _duplicate (Sentence_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sentence_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sentence_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sentence_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sentence_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sentence_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sentence_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sentence_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sentence_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sentence_& instance) = 0;

            protected:
                Sentence_DataReaderView () {};
                ~Sentence_DataReaderView () {};
            private:
                Sentence_DataReaderView (const Sentence_DataReaderView &);
                Sentence_DataReaderView & operator = (const Sentence_DataReaderView &);
            };
        }

    }

}

#endif
