// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nmea_msgs:msg/Gpgga.idl
// generated code does not contain a copyright notice
#include "nmea_msgs/msg/gpgga__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `message_id`
// Member `lat_dir`
// Member `lon_dir`
// Member `altitude_units`
// Member `undulation_units`
// Member `station_id`
#include "rosidl_generator_c/string_functions.h"

bool
nmea_msgs__msg__Gpgga__init(nmea_msgs__msg__Gpgga * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    nmea_msgs__msg__Gpgga__fini(msg);
    return false;
  }
  // message_id
  if (!rosidl_generator_c__String__init(&msg->message_id)) {
    nmea_msgs__msg__Gpgga__fini(msg);
    return false;
  }
  // utc_seconds
  // lat
  // lon
  // lat_dir
  if (!rosidl_generator_c__String__init(&msg->lat_dir)) {
    nmea_msgs__msg__Gpgga__fini(msg);
    return false;
  }
  // lon_dir
  if (!rosidl_generator_c__String__init(&msg->lon_dir)) {
    nmea_msgs__msg__Gpgga__fini(msg);
    return false;
  }
  // gps_qual
  // num_sats
  // hdop
  // alt
  // altitude_units
  if (!rosidl_generator_c__String__init(&msg->altitude_units)) {
    nmea_msgs__msg__Gpgga__fini(msg);
    return false;
  }
  // undulation
  // undulation_units
  if (!rosidl_generator_c__String__init(&msg->undulation_units)) {
    nmea_msgs__msg__Gpgga__fini(msg);
    return false;
  }
  // diff_age
  // station_id
  if (!rosidl_generator_c__String__init(&msg->station_id)) {
    nmea_msgs__msg__Gpgga__fini(msg);
    return false;
  }
  return true;
}

void
nmea_msgs__msg__Gpgga__fini(nmea_msgs__msg__Gpgga * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // message_id
  rosidl_generator_c__String__fini(&msg->message_id);
  // utc_seconds
  // lat
  // lon
  // lat_dir
  rosidl_generator_c__String__fini(&msg->lat_dir);
  // lon_dir
  rosidl_generator_c__String__fini(&msg->lon_dir);
  // gps_qual
  // num_sats
  // hdop
  // alt
  // altitude_units
  rosidl_generator_c__String__fini(&msg->altitude_units);
  // undulation
  // undulation_units
  rosidl_generator_c__String__fini(&msg->undulation_units);
  // diff_age
  // station_id
  rosidl_generator_c__String__fini(&msg->station_id);
}

nmea_msgs__msg__Gpgga *
nmea_msgs__msg__Gpgga__create()
{
  nmea_msgs__msg__Gpgga * msg = (nmea_msgs__msg__Gpgga *)malloc(sizeof(nmea_msgs__msg__Gpgga));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nmea_msgs__msg__Gpgga));
  bool success = nmea_msgs__msg__Gpgga__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
nmea_msgs__msg__Gpgga__destroy(nmea_msgs__msg__Gpgga * msg)
{
  if (msg) {
    nmea_msgs__msg__Gpgga__fini(msg);
  }
  free(msg);
}


bool
nmea_msgs__msg__Gpgga__Sequence__init(nmea_msgs__msg__Gpgga__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  nmea_msgs__msg__Gpgga * data = NULL;
  if (size) {
    data = (nmea_msgs__msg__Gpgga *)calloc(size, sizeof(nmea_msgs__msg__Gpgga));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nmea_msgs__msg__Gpgga__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nmea_msgs__msg__Gpgga__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nmea_msgs__msg__Gpgga__Sequence__fini(nmea_msgs__msg__Gpgga__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nmea_msgs__msg__Gpgga__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nmea_msgs__msg__Gpgga__Sequence *
nmea_msgs__msg__Gpgga__Sequence__create(size_t size)
{
  nmea_msgs__msg__Gpgga__Sequence * array = (nmea_msgs__msg__Gpgga__Sequence *)malloc(sizeof(nmea_msgs__msg__Gpgga__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = nmea_msgs__msg__Gpgga__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
nmea_msgs__msg__Gpgga__Sequence__destroy(nmea_msgs__msg__Gpgga__Sequence * array)
{
  if (array) {
    nmea_msgs__msg__Gpgga__Sequence__fini(array);
  }
  free(array);
}
